package com.qmth.boot.core.metrics.service.impl;

import com.qmth.boot.core.metrics.model.TimeRange;

import java.util.concurrent.atomic.AtomicLong;

public class TimeCounter {

    private TimeRange range;

    private AtomicLong count;

    public TimeCounter(long ge, long lt) {
        this.range = new TimeRange(ge, lt);
        this.count = new AtomicLong(0);
    }

    public TimeRange getTimeRage() {
        return this.range;
    }

    public boolean accept(long timecost) {
        if (timecost >= range.getGe() && (range.getLt() < 0 || timecost < range.getLt())) {
            count.incrementAndGet();
            return true;
        } else {
            return false;
        }
    }

    public long count() {
        return count.get();
    }

}
