package com.qmth.boot.api.interceptor;

import com.qmth.boot.api.config.AacConfig;
import com.qmth.boot.api.config.ApiConfigService;
import com.qmth.boot.api.config.ApiProperties;
import com.qmth.boot.api.constant.ApiConstant;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.method.HandlerMethod;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import javax.servlet.http.HttpServletRequest;

public abstract class AbstractInterceptor extends HandlerInterceptorAdapter implements ApiConstant {

    protected final Logger log = LoggerFactory.getLogger(this.getClass());

    protected AacConfig getAacConfig(ApiProperties apiProperties, ApiConfigService apiConfigService,
            HttpServletRequest request, Object handler) {
        AacConfig aacConfig = getAacConfig(request);
        if (aacConfig == null) {
            if (handler instanceof HandlerMethod) {
                aacConfig = apiConfigService.getAacConfig((HandlerMethod) handler);
            } else {
                aacConfig = new AacConfig(apiProperties);
            }
            request.setAttribute(ATTRIBUTE_AAC_CONFIG, aacConfig);
        }
        return aacConfig;
    }

    private AacConfig getAacConfig(HttpServletRequest request) {
        Object obj = request.getAttribute(ATTRIBUTE_AAC_CONFIG);
        if (obj instanceof AacConfig) {
            return (AacConfig) obj;
        } else {
            return null;
        }
    }

}
